import { InternalTypeSymbol, JsonValue, SchemaLike } from "./json-schema";
declare const hiddenField: unique symbol;
declare type TsjsonString<T> = string & {
    [hiddenField]: T extends JsonValue ? T : unknown;
};
export declare const TSJSON: {
    parse: <T>(input: TsjsonString<T>) => T;
    stringify: <T_1>(input: T_1) => TsjsonString<T_1>;
};
export declare type Validated<T extends SchemaLike> = T[typeof InternalTypeSymbol];
export declare class TsjsonParser<T extends SchemaLike> {
    readonly schema: T;
    private readonly validator;
    constructor(schema: T);
    validate(data: unknown): asserts data is Validated<T>;
    parse: (text: string, skipValidation?: boolean) => T[typeof InternalTypeSymbol];
}
export {};
