"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ajv_1 = __importDefault(require("ajv"));
const hiddenField = Symbol("SpecialTypeAnnotationFieldDoNotUse");
exports.TSJSON = {
    parse: (input) => JSON.parse(input),
    stringify: (input) => JSON.stringify(input)
};
class TsjsonParser {
    constructor(schema) {
        this.parse = (text, skipValidation = false) => {
            const data = JSON.parse(text);
            if (skipValidation) {
                return data;
            }
            this.validate(data);
            return data;
        };
        this.schema = schema;
        const ajv = new ajv_1.default();
        this.validator = ajv.compile(schema);
    }
    validate(data) {
        const valid = this.validator(data);
        if (!valid) {
            throw new Error(JSON.stringify(this.validator.errors));
        }
    }
}
exports.TsjsonParser = TsjsonParser;
